FROM debian:12.9-slim AS build0

RUN apt-get -y update \
        && apt-get -y install --no-install-recommends \
        perl build-essential libexpat1-dev libssl-dev \
        libnet-ssleay-perl libcrypt-ssleay-perl openssh-client libxml-parser-perl \
        libxml-sax-expat-perl libxml-simple-perl libfurl-perl libio-socket-ssl-perl \
        libmoose-perl libconfig-general-perl &&\
        rm -rf /var/lib/apt/lists/*



FROM build0 AS build1

# conigure cpan to auto install dependencies
RUN perl -MCPAN -e 'my $c = "CPAN::HandleConfig"; $c->load(doit => 1, autoconfig => 1); $c->edit(prerequisites_policy => "follow"); $c->edit(build_requires_install_policy => "yes"); $c->commit'

RUN  cpan install Nice::Try &&\
        cpan install Pod::Usage &&\
        cpan install Log::Log4perl &&\
        cpan install Paws &&\
        rm -rf /usr/local/share/man &&\
        rm -rf /root/.cpan &&\
        cd /usr/local &&\
        tar -zcvf /tmp/ul.tgz *



FROM build0

COPY src/launchotron /app/launchotron
COPY --from=build1 /tmp/ul.tgz /tmp/

RUN rm -rf /usr/local/* &&\
        cd /usr/local &&\
        tar -zxf /tmp/ul.tgz &&\
        rm -f /tmp/ul.tgz


ENTRYPOINT [ "/app/launchotron" ]
